searchData={"items":[{"type":"module","title":"ExAcme","doc":"ExAcme is an ACME protocol client for managing SSL certificates.\n\nIt provides functionalities to interact with the ACME server, including\ngenerating keys, sending ACME requests, and handling directory and nonce\ninformation.","ref":"ExAcme.html"},{"type":"module","title":"Features - ExAcme","doc":"- Start and manage the ExAcme client agent.\n  - Fetch directory information and terms of service.\n  - Send signed ACME requests.\n  - Handle nonce refreshing automatically.\n\nUse the client to interact with ACME endpoints.","ref":"ExAcme.html#module-features"},{"type":"function","title":"ExAcme.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExAcme.html#child_spec/1"},{"type":"type","title":"ExAcme.client/0","doc":"Client process holding directory cache and state","ref":"ExAcme.html#t:client/0"},{"type":"function","title":"ExAcme.directory/1","doc":"Retrieves the directory information from the client.","ref":"ExAcme.html#directory/1"},{"type":"function","title":"Parameters - ExAcme.directory/1","doc":"- `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#directory/1-parameters"},{"type":"function","title":"ExAcme.external_account_required?/1","doc":"Checks if an external account is required.","ref":"ExAcme.html#external_account_required?/1"},{"type":"function","title":"Parameters - ExAcme.external_account_required?/1","doc":"- `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#external_account_required?/1-parameters"},{"type":"function","title":"ExAcme.profiles/1","doc":"Retrieves the profiles from the ACME directory.","ref":"ExAcme.html#profiles/1"},{"type":"function","title":"Parameters - ExAcme.profiles/1","doc":"- `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#profiles/1-parameters"},{"type":"function","title":"ExAcme.send_request/3","doc":"Sends an ACME request.","ref":"ExAcme.html#send_request/3"},{"type":"function","title":"Parameters - ExAcme.send_request/3","doc":"- `acme_request` - The ACME request to send.\n  - `account_key` - The account key for signing.\n  - `client` - The ExAcme client agent.","ref":"ExAcme.html#send_request/3-parameters"},{"type":"function","title":"ExAcme.start_link/1","doc":"Starts the ExAcme client agent with the given options.","ref":"ExAcme.html#start_link/1"},{"type":"function","title":"Options - ExAcme.start_link/1","doc":"- `:directory_url` - The URL of the ACME directory.\n  - `:finch` - The module name or pid of the Finch HTTP client to use.","ref":"ExAcme.html#start_link/1-options"},{"type":"function","title":"ExAcme.terms_of_service/1","doc":"Retrieves the terms of service URL from the ACME directory information.","ref":"ExAcme.html#terms_of_service/1"},{"type":"function","title":"Parameters - ExAcme.terms_of_service/1","doc":"- `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#terms_of_service/1-parameters"},{"type":"module","title":"ExAcme.Account","doc":"Represents an [ACME Account object](https://www.rfc-editor.org/rfc/rfc8555.html#section-7.1.2).\n\nProvides functionalities to fetch account details from the ACME server.","ref":"ExAcme.Account.html"},{"type":"module","title":"Attributes - ExAcme.Account","doc":"- `url` - The URL of the account.\n  - `status` - The current status of the account.\n  - `contact_urls` - List of contact URLs.\n  - `terms_of_service_agreed` - Boolean indicating agreement to terms of service.\n  - `external_account_binding` - External account binding information.\n  - `orders_url` - URL to fetch the list of orders.","ref":"ExAcme.Account.html#module-attributes"},{"type":"function","title":"ExAcme.Account.fetch/3","doc":"Fetches an account from the ACME server.","ref":"ExAcme.Account.html#fetch/3"},{"type":"function","title":"Parameters - ExAcme.Account.fetch/3","doc":"- `url` - The account URL.\n  - `account_key` - The account key for authentication.\n  - `client` - The ExAcme client agent.","ref":"ExAcme.Account.html#fetch/3-parameters"},{"type":"function","title":"Returns - ExAcme.Account.fetch/3","doc":"- `{:ok, account}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.Account.html#fetch/3-returns"},{"type":"type","title":"ExAcme.Account.t/0","doc":"ACME Account object","ref":"ExAcme.Account.html#t:t/0"},{"type":"module","title":"ExAcme.AccountKey","doc":"Handles the ACME account key operations.\n\nProvides functionalities to generate keys, sign requests, and manage key identifiers.","ref":"ExAcme.AccountKey.html"},{"type":"module","title":"Attributes - ExAcme.AccountKey","doc":"- `key` - The JOSE JSON Web Key (JWK).\n  - `type` - The type of the key (e.g., :ec256, :ed25519).\n  - `kid` - The Key ID assigned by the server.","ref":"ExAcme.AccountKey.html#module-attributes"},{"type":"function","title":"ExAcme.AccountKey.from_json/1","doc":"Deserializes the account key from JSON.","ref":"ExAcme.AccountKey.html#from_json/1"},{"type":"function","title":"Parameters - ExAcme.AccountKey.from_json/1","doc":"- `json` - The JSON string representing the account key.","ref":"ExAcme.AccountKey.html#from_json/1-parameters"},{"type":"function","title":"Returns - ExAcme.AccountKey.from_json/1","doc":"- `{:ok, %ExAcme.AccountKey{}}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.AccountKey.html#from_json/1-returns"},{"type":"function","title":"ExAcme.AccountKey.generate/1","doc":"Generates a new account key.","ref":"ExAcme.AccountKey.html#generate/1"},{"type":"function","title":"Parameters - ExAcme.AccountKey.generate/1","doc":"- `type` - The type of key to generate (:ec256 or :ed25519). Defaults to :ec256.","ref":"ExAcme.AccountKey.html#generate/1-parameters"},{"type":"function","title":"Returns - ExAcme.AccountKey.generate/1","doc":"- `%ExAcme.AccountKey{}` struct.","ref":"ExAcme.AccountKey.html#generate/1-returns"},{"type":"function","title":"ExAcme.AccountKey.sign/3","doc":"Signs a request body with the account key.","ref":"ExAcme.AccountKey.html#sign/3"},{"type":"function","title":"Parameters - ExAcme.AccountKey.sign/3","doc":"- `account_key` - The account key.\n  - `body` - The request body to sign.\n  - `header` - Additional headers.","ref":"ExAcme.AccountKey.html#sign/3-parameters"},{"type":"function","title":"Returns - ExAcme.AccountKey.sign/3","doc":"- The signed JWS.","ref":"ExAcme.AccountKey.html#sign/3-returns"},{"type":"type","title":"ExAcme.AccountKey.t/0","doc":"Account key for authenticating requests","ref":"ExAcme.AccountKey.html#t:t/0"},{"type":"function","title":"ExAcme.AccountKey.thumbprint/1","doc":"Generates the thumbprint of the account key.","ref":"ExAcme.AccountKey.html#thumbprint/1"},{"type":"function","title":"Parameters - ExAcme.AccountKey.thumbprint/1","doc":"- `account_key` - The account key.","ref":"ExAcme.AccountKey.html#thumbprint/1-parameters"},{"type":"function","title":"Returns - ExAcme.AccountKey.thumbprint/1","doc":"- The thumbprint as a string.","ref":"ExAcme.AccountKey.html#thumbprint/1-returns"},{"type":"function","title":"ExAcme.AccountKey.to_json/1","doc":"Serializes the account key to JSON.","ref":"ExAcme.AccountKey.html#to_json/1"},{"type":"function","title":"Parameters - ExAcme.AccountKey.to_json/1","doc":"- `account_key` - The account key.","ref":"ExAcme.AccountKey.html#to_json/1-parameters"},{"type":"function","title":"Returns - ExAcme.AccountKey.to_json/1","doc":"- JSON string representation of the account key.","ref":"ExAcme.AccountKey.html#to_json/1-returns"},{"type":"function","title":"ExAcme.AccountKey.to_public/1","doc":"Converts the account key to its public representation.","ref":"ExAcme.AccountKey.html#to_public/1"},{"type":"function","title":"Parameters - ExAcme.AccountKey.to_public/1","doc":"- `account_key` - The account key.","ref":"ExAcme.AccountKey.html#to_public/1-parameters"},{"type":"function","title":"Returns - ExAcme.AccountKey.to_public/1","doc":"- A map representing the public JWK.","ref":"ExAcme.AccountKey.html#to_public/1-returns"},{"type":"function","title":"ExAcme.AccountKey.update_kid/2","doc":"Updates the Key ID (KID) of the account key.","ref":"ExAcme.AccountKey.html#update_kid/2"},{"type":"function","title":"Parameters - ExAcme.AccountKey.update_kid/2","doc":"- `key` - The account key.\n  - `kid` - The new Key ID.","ref":"ExAcme.AccountKey.html#update_kid/2-parameters"},{"type":"function","title":"Returns - ExAcme.AccountKey.update_kid/2","doc":"- Updated `%ExAcme.AccountKey{}` struct.","ref":"ExAcme.AccountKey.html#update_kid/2-returns"},{"type":"module","title":"ExAcme.Authorization","doc":"Represents an [ACME Authorization object](https://www.rfc-editor.org/rfc/rfc8555.html#section-7.1.4).\n\nProvides functionalities to fetch and process authorization details from the ACME server.","ref":"ExAcme.Authorization.html"},{"type":"module","title":"Attributes - ExAcme.Authorization","doc":"- `url` - The URL of the authorization.\n  - `status` - The current status of the authorization.\n  - `expires` - Expiration datetime of the authorization.\n  - `identifier` - The identifier (e.g., domain) associated with the authorization.\n  - `challenges` - List of challenges available for the authorization.\n  - `wildcard` - Boolean indicating if the authorization is for a wildcard domain.","ref":"ExAcme.Authorization.html#module-attributes"},{"type":"function","title":"ExAcme.Authorization.fetch/3","doc":"Fetches an authorization from the ACME server.","ref":"ExAcme.Authorization.html#fetch/3"},{"type":"function","title":"Parameters - ExAcme.Authorization.fetch/3","doc":"- `url` - The authorization URL.\n  - `account_key` - The account key for authentication.\n  - `client` - The ExAcme client agent.","ref":"ExAcme.Authorization.html#fetch/3-parameters"},{"type":"function","title":"Returns - ExAcme.Authorization.fetch/3","doc":"- `{:ok, authorization}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.Authorization.html#fetch/3-returns"},{"type":"type","title":"ExAcme.Authorization.t/0","doc":"ACME Authorization object","ref":"ExAcme.Authorization.html#t:t/0"},{"type":"module","title":"ExAcme.Certificate","doc":"Handles ACME certificate operations.\n\nProvides functionalities to fetch certificates and generate Certificate Signing Requests (CSRs).","ref":"ExAcme.Certificate.html"},{"type":"function","title":"ExAcme.Certificate.csr_from_order/2","doc":"Generates a Certificate Signing Request (CSR) from an order and a private key.","ref":"ExAcme.Certificate.html#csr_from_order/2"},{"type":"function","title":"Parameters - ExAcme.Certificate.csr_from_order/2","doc":"- `order` - The ACME order.\n  - `private_key` - The private key to sign the CSR and associate with the certificate.","ref":"ExAcme.Certificate.html#csr_from_order/2-parameters"},{"type":"function","title":"Returns - ExAcme.Certificate.csr_from_order/2","doc":"- `%X509.CSR{}` struct.","ref":"ExAcme.Certificate.html#csr_from_order/2-returns"},{"type":"function","title":"ExAcme.Certificate.fetch/3","doc":"Fetches a certificate chain from the ACME server.","ref":"ExAcme.Certificate.html#fetch/3"},{"type":"function","title":"Parameters - ExAcme.Certificate.fetch/3","doc":"- `url` - The certificate URL.\n  - `account_key` - The account key for authentication.\n  - `client` - The ExAcme client agent.","ref":"ExAcme.Certificate.html#fetch/3-parameters"},{"type":"function","title":"Returns - ExAcme.Certificate.fetch/3","doc":"- `{:ok, certificates}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.Certificate.html#fetch/3-returns"},{"type":"module","title":"ExAcme.Challenge","doc":"Represents an [ACME Challenge object](https://www.rfc-editor.org/rfc/rfc8555.html#section-7.1.5).\n\nProvides functionalities to handle challenges required for validation.","ref":"ExAcme.Challenge.html"},{"type":"module","title":"Attributes - ExAcme.Challenge","doc":"- `url` - The URL of the challenge.\n  - `status` - The current status of the challenge.\n  - `type` - The type of challenge (e.g., \"dns-01\").\n  - `token` - The challenge token.\n  - `validated` - Datetime when the challenge was validated.\n  - `error` - Any error associated with the challenge.","ref":"ExAcme.Challenge.html#module-attributes"},{"type":"function","title":"ExAcme.Challenge.fetch/3","doc":"Fetches a challenge from the ACME server.","ref":"ExAcme.Challenge.html#fetch/3"},{"type":"function","title":"Parameters - ExAcme.Challenge.fetch/3","doc":"- `url` - The challenge URL.\n  - `account_key` - The account key for authentication.\n  - `client` - The ExAcme client agent.","ref":"ExAcme.Challenge.html#fetch/3-parameters"},{"type":"function","title":"Returns - ExAcme.Challenge.fetch/3","doc":"- `{:ok, challenge}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.Challenge.html#fetch/3-returns"},{"type":"function","title":"ExAcme.Challenge.find_by_type/2","doc":"Finds a challenge of a specific type within an authorization.","ref":"ExAcme.Challenge.html#find_by_type/2"},{"type":"function","title":"Parameters - ExAcme.Challenge.find_by_type/2","doc":"- `authorization` - The authorization map.\n  - `type` - The type of challenge to find (e.g., \"dns-01\").","ref":"ExAcme.Challenge.html#find_by_type/2-parameters"},{"type":"function","title":"Returns - ExAcme.Challenge.find_by_type/2","doc":"- The challenge object if found, else `nil`.","ref":"ExAcme.Challenge.html#find_by_type/2-returns"},{"type":"function","title":"ExAcme.Challenge.key_authorization/2","doc":"Generates the key authorization string for a challenge.","ref":"ExAcme.Challenge.html#key_authorization/2"},{"type":"function","title":"Parameters - ExAcme.Challenge.key_authorization/2","doc":"- `token` - The challenge token.\n  - `account_key` - The account key.","ref":"ExAcme.Challenge.html#key_authorization/2-parameters"},{"type":"function","title":"Returns - ExAcme.Challenge.key_authorization/2","doc":"- The key authorization string.","ref":"ExAcme.Challenge.html#key_authorization/2-returns"},{"type":"type","title":"ExAcme.Challenge.t/0","doc":"ACME Challenge Object","ref":"ExAcme.Challenge.html#t:t/0"},{"type":"function","title":"ExAcme.Challenge.trigger_validation/3","doc":"Triggers the validation of a challenge.","ref":"ExAcme.Challenge.html#trigger_validation/3"},{"type":"function","title":"Parameters - ExAcme.Challenge.trigger_validation/3","doc":"- `url` - The challenge URL.\n  - `account_key` - The account key for authentication.\n  - `client` - The ExAcme client agent.","ref":"ExAcme.Challenge.html#trigger_validation/3-parameters"},{"type":"function","title":"Returns - ExAcme.Challenge.trigger_validation/3","doc":"- `{:ok, challenge}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.Challenge.html#trigger_validation/3-returns"},{"type":"module","title":"ExAcme.Order","doc":"Represents an [ACME Order object](https://tools.ietf.org/html/rfc8555#section-7.1.3).\n\nProvides functionalities to fetch, finalize, and parse order details from the ACME server.","ref":"ExAcme.Order.html"},{"type":"module","title":"Attributes - ExAcme.Order","doc":"- `url` - The URL of the order.\n  - `status` - The current status of the order.\n  - `expires` - Expiration datetime of the order.\n  - `identifiers` - List of domain identifiers associated with the order.\n  - `profile` - The profile associated with the order.\n  - `not_before` - Start datetime of the order's validity.\n  - `not_after` - End datetime of the order's validity.\n  - `error` - Any error associated with the order.\n  - `authorizations` - List of authorization URLs.\n  - `finalize_url` - URL to finalize the order.\n  - `certificate_url` - URL to retrieve the issued certificate.","ref":"ExAcme.Order.html#module-attributes"},{"type":"function","title":"ExAcme.Order.fetch/3","doc":"Fetches an order from the ACME server.","ref":"ExAcme.Order.html#fetch/3"},{"type":"function","title":"Parameters - ExAcme.Order.fetch/3","doc":"- `url` - The order URL.\n  - `account_key` - The account key for authentication.\n  - `client` - The ExAcme client agent.","ref":"ExAcme.Order.html#fetch/3-parameters"},{"type":"function","title":"Returns - ExAcme.Order.fetch/3","doc":"- `{:ok, order}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.Order.html#fetch/3-returns"},{"type":"function","title":"ExAcme.Order.finalize/4","doc":"Finalizes an order by submitting a Certificate Signing Request (CSR).","ref":"ExAcme.Order.html#finalize/4"},{"type":"function","title":"Parameters - ExAcme.Order.finalize/4","doc":"- `finalize_url` - The finalize URL from the order.\n  - `csr` - The Certificate Signing Request.\n  - `account_key` - The account key for authentication.\n  - `client` - The ExAcme client agent.","ref":"ExAcme.Order.html#finalize/4-parameters"},{"type":"function","title":"Returns - ExAcme.Order.finalize/4","doc":"- `{:ok, order}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.Order.html#finalize/4-returns"},{"type":"type","title":"ExAcme.Order.t/0","doc":"ACME Order object","ref":"ExAcme.Order.html#t:t/0"},{"type":"module","title":"ExAcme.OrderRequest","doc":"Represents an [ACME Order request](https://www.rfc-editor.org/rfc/rfc8555.html#section-7.4).\n\nProvides functionalities to build and submit order requests to the ACME server.","ref":"ExAcme.OrderRequest.html"},{"type":"module","title":"Attributes - ExAcme.OrderRequest","doc":"- `identifiers` - List of identifiers for the order.\n  - `profile` - The profile to apply to the order.\n  - `not_before` - Request start time for the certificate.\n  - `not_after` - Request end time for the certificate.","ref":"ExAcme.OrderRequest.html#module-attributes"},{"type":"function","title":"ExAcme.OrderRequest.add_dns_identifier/2","doc":"Adds a DNS identifier to the order request.","ref":"ExAcme.OrderRequest.html#add_dns_identifier/2"},{"type":"function","title":"Parameters - ExAcme.OrderRequest.add_dns_identifier/2","doc":"- `order` - The current order request.\n  - `domain` - The domain name to add.","ref":"ExAcme.OrderRequest.html#add_dns_identifier/2-parameters"},{"type":"function","title":"Returns - ExAcme.OrderRequest.add_dns_identifier/2","doc":"- Updated `%ExAcme.OrderRequest{}` struct.","ref":"ExAcme.OrderRequest.html#add_dns_identifier/2-returns"},{"type":"function","title":"ExAcme.OrderRequest.add_identifier/3","doc":"Adds an identifier to the order request.","ref":"ExAcme.OrderRequest.html#add_identifier/3"},{"type":"function","title":"Parameters - ExAcme.OrderRequest.add_identifier/3","doc":"- `order` - The current order request.\n  - `type` - The type of identifier (e.g., \"dns\").\n  - `value` - The value of the identifier (e.g., domain name).","ref":"ExAcme.OrderRequest.html#add_identifier/3-parameters"},{"type":"function","title":"Returns - ExAcme.OrderRequest.add_identifier/3","doc":"- Updated `%ExAcme.OrderRequest{}` struct.","ref":"ExAcme.OrderRequest.html#add_identifier/3-returns"},{"type":"function","title":"ExAcme.OrderRequest.new/0","doc":"Creates a new order request with default values.","ref":"ExAcme.OrderRequest.html#new/0"},{"type":"function","title":"Returns - ExAcme.OrderRequest.new/0","doc":"- `%ExAcme.OrderRequest{}` struct.","ref":"ExAcme.OrderRequest.html#new/0-returns"},{"type":"function","title":"ExAcme.OrderRequest.not_after/2","doc":"Sets the requested end time for the certificate.","ref":"ExAcme.OrderRequest.html#not_after/2"},{"type":"function","title":"Parameters - ExAcme.OrderRequest.not_after/2","doc":"- `order` - The current order request.\n  - `date` - The end datetime.","ref":"ExAcme.OrderRequest.html#not_after/2-parameters"},{"type":"function","title":"Returns - ExAcme.OrderRequest.not_after/2","doc":"- Updated `%ExAcme.OrderRequest{}` struct.","ref":"ExAcme.OrderRequest.html#not_after/2-returns"},{"type":"function","title":"ExAcme.OrderRequest.not_before/2","doc":"Sets the requested start time for the certificate.","ref":"ExAcme.OrderRequest.html#not_before/2"},{"type":"function","title":"Parameters - ExAcme.OrderRequest.not_before/2","doc":"- `order` - The current order request.\n  - `date` - The start datetime.","ref":"ExAcme.OrderRequest.html#not_before/2-parameters"},{"type":"function","title":"Returns - ExAcme.OrderRequest.not_before/2","doc":"- Updated `%ExAcme.OrderRequest{}` struct.","ref":"ExAcme.OrderRequest.html#not_before/2-returns"},{"type":"function","title":"ExAcme.OrderRequest.profile/2","doc":"Sets the profile for the order request.","ref":"ExAcme.OrderRequest.html#profile/2"},{"type":"function","title":"Parameters - ExAcme.OrderRequest.profile/2","doc":"- `order` - The current order request.\n  - `profile` - The profile name.","ref":"ExAcme.OrderRequest.html#profile/2-parameters"},{"type":"function","title":"Returns - ExAcme.OrderRequest.profile/2","doc":"- Updated `%ExAcme.OrderRequest{}` struct.","ref":"ExAcme.OrderRequest.html#profile/2-returns"},{"type":"function","title":"ExAcme.OrderRequest.submit/3","doc":"Submits the order request to the ACME server.","ref":"ExAcme.OrderRequest.html#submit/3"},{"type":"function","title":"Parameters - ExAcme.OrderRequest.submit/3","doc":"- `order` - The order request to submit.\n  - `key` - The account key for authentication.\n  - `client` - The ExAcme client agent.","ref":"ExAcme.OrderRequest.html#submit/3-parameters"},{"type":"function","title":"Returns - ExAcme.OrderRequest.submit/3","doc":"- `{:ok, order}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.OrderRequest.html#submit/3-returns"},{"type":"type","title":"ExAcme.OrderRequest.t/0","doc":"ACME Order request object","ref":"ExAcme.OrderRequest.html#t:t/0"},{"type":"module","title":"ExAcme.Registration","doc":"Represents an [ACME Account registration](https://www.rfc-editor.org/rfc/rfc8555.html#section-7.3).\n\nProvides functionalities to create and manage account registrations with the ACME server.","ref":"ExAcme.Registration.html"},{"type":"module","title":"Attributes - ExAcme.Registration","doc":"- `contact` - List of contact URIs.\n  - `terms_of_service_agreed` - Boolean indicating agreement to terms.\n  - `only_return_existing` - Boolean to indicate if only existing accounts should be returned.\n  - `external_account_binding` - External account binding information.","ref":"ExAcme.Registration.html#module-attributes"},{"type":"function","title":"ExAcme.Registration.agree_to_terms/1","doc":"Agrees to the terms of service for the registration.","ref":"ExAcme.Registration.html#agree_to_terms/1"},{"type":"function","title":"Parameters - ExAcme.Registration.agree_to_terms/1","doc":"- `registration` - The current registration struct.","ref":"ExAcme.Registration.html#agree_to_terms/1-parameters"},{"type":"function","title":"Returns - ExAcme.Registration.agree_to_terms/1","doc":"- Updated `%ExAcme.Registration{}` struct.","ref":"ExAcme.Registration.html#agree_to_terms/1-returns"},{"type":"function","title":"ExAcme.Registration.contacts/2","doc":"Adds contact URIs to the registration.","ref":"ExAcme.Registration.html#contacts/2"},{"type":"function","title":"Parameters - ExAcme.Registration.contacts/2","doc":"- `registration` - The current registration struct.\n  - `contacts` - A list or single contact URI.","ref":"ExAcme.Registration.html#contacts/2-parameters"},{"type":"function","title":"Returns - ExAcme.Registration.contacts/2","doc":"- Updated `%ExAcme.Registration{}` struct.","ref":"ExAcme.Registration.html#contacts/2-returns"},{"type":"function","title":"ExAcme.Registration.new/0","doc":"Creates a new account registration struct with default values.","ref":"ExAcme.Registration.html#new/0"},{"type":"function","title":"Returns - ExAcme.Registration.new/0","doc":"- `%ExAcme.Registration{}` struct.","ref":"ExAcme.Registration.html#new/0-returns"},{"type":"function","title":"ExAcme.Registration.register/4","doc":"Registers the account with the ACME server.","ref":"ExAcme.Registration.html#register/4"},{"type":"function","title":"Parameters - ExAcme.Registration.register/4","doc":"- `registration` - The registration struct.\n  - `account_key` - The account key for authentication.\n  - `client` - The ExAcme client agent.\n  - `opts` - Optional parameters.","ref":"ExAcme.Registration.html#register/4-parameters"},{"type":"function","title":"Options - ExAcme.Registration.register/4","doc":"- `:only_return_existing` - If true, only existing accounts will be returned.","ref":"ExAcme.Registration.html#register/4-options"},{"type":"function","title":"Returns - ExAcme.Registration.register/4","doc":"- `{:ok, account}` on success.\n  - `{:error, reason}` on failure.","ref":"ExAcme.Registration.html#register/4-returns"},{"type":"type","title":"ExAcme.Registration.t/0","doc":"ACME Account registration object","ref":"ExAcme.Registration.html#t:t/0"},{"type":"protocol","title":"ExAcme.Request","doc":"","ref":"ExAcme.Request.html"},{"type":"type","title":"ExAcme.Request.t/0","doc":"All the types that implement this protocol.","ref":"ExAcme.Request.html#t:t/0"},{"type":"extras","title":"ExAcme","doc":"# ExAcme\n\nExAcme is a lightweight, developer-friendly Elixir library for interacting with [RFC 8555-compliant](https://tools.ietf.org/html/rfc8555) ACME servers like [Let’s Encrypt](https://letsencrypt.org). It simplifies the process of managing X.509 (TLS/SSL) certificates by providing a straightforward API for registering accounts, handling domain challenges, and issuing certificates.","ref":"readme.html"},{"type":"extras","title":"Features - ExAcme","doc":"- Designed with developer productivity and Elixir idioms in mind.\n- Easy integration into your projects with minimal configuration.","ref":"readme.html#features"},{"type":"extras","title":"Missing - ExAcme","doc":"- Handling external account binding","ref":"readme.html#missing"},{"type":"extras","title":"Installation - ExAcme","doc":"The package can be installed by adding `ex_acme` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_acme, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc) and published on [HexDocs](https://hexdocs.pm). The docs can be found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Examples - ExAcme","doc":"","ref":"readme.html#examples"},{"type":"extras","title":"Registering an account - ExAcme","doc":"To register a new account with the ACME server, you need to generate an account key, create a registration, and agree to the terms of service.\n\n```elixir\nalias ExAcme.{AccountKey, Registration}\n\nFinch.start_link(name: MyFinch)\n{:ok, client} = ExAcme.start_link(directory_url: :lets_encrypt_staging, finch: MyFinch)\n\n# Generate a new account key\naccount_key = AccountKey.generate()\n\n# Create and configure the registration\nregistration =\n  Registration.new()\n  |> Registration.contacts([\"mailto:admin@example.com\"])\n  |> Registration.agree_to_terms()\n\n# Register the account\ncase Registration.register(registration, account_key, client) do\n  {:ok, account} ->\n    IO.puts(\"Account registered successfully!\")\n    IO.inspect(account)\n\n  {:error, reason} ->\n    IO.puts(\"Failed to register account:\")\n    IO.inspect(reason)\nend\n```","ref":"readme.html#registering-an-account"},{"type":"extras","title":"Creating an order request - ExAcme","doc":"Once you have registered an account, you can create an order for a certificate by specifying the domain(s) you wish to obtain certificates for.\n\n```elixir\nalias ExAcme.OrderRequest\n\n# Create a new order request\norder_request =\n  OrderRequest.new()\n  |> OrderRequest.add_dns_identifier(\"example.com\")\n  |> OrderRequest.add_dns_identifier(\"www.example.com\")\n\n# Submit the order\ncase OrderRequest.submit(order_request, account_key, client) do\n  {:ok, order} ->\n    IO.puts(\"Order created successfully!\")\n    IO.inspect(order)\n\n  {:error, reason} ->\n    IO.puts(\"Failed to create order:\")\n    IO.inspect(reason)\nend\n```","ref":"readme.html#creating-an-order-request"},{"type":"extras","title":"Fetching the challenges for the order - ExAcme","doc":"After creating an order, you need to complete the necessary challenges to prove ownership of the domain.\n\n```elixir\nalias ExAcme.{Authorization, Challenge}\n\nfor auth_url <- order.authorizations do\n  {:ok, authorization} = Authorization.fetch(auth_url, account_key, client)\n  challenge = Challenge.find_by_type(authorization, \"dns-01\")\n\n  if challenge do\n    value = Challenge.key_authorization(challenge.token, account_key)\n    # Set up challenge (implementation depends on your setup)\n    setup_challenge(authorization.identifier[\"value\"], value)\n\n    # Trigger validation\n    {:ok, _validated_challenge} = Challenge.trigger_validation(challenge.url, account_key, client)\n\n    # Optionally, wait and verify the challenge status\n    :timer.sleep(5000)\n    {:ok, validated_challenge} = Challenge.fetch(challenge.url, account_key, client)\n\n    if validated_challenge.status == \"valid\" do\n      IO.puts(\"Challenge for #{authorization.identifier[\"value\"]} validated successfully.\")\n    else\n      IO.puts(\"Challenge for #{authorization.identifier[\"value\"]} failed.\")\n    end\n  else\n    IO.puts(\"No challenge found for #{authorization.identifier[\"value\"]}.\")\n  end\nend\n```","ref":"readme.html#fetching-the-challenges-for-the-order"},{"type":"extras","title":"Finalizing the order with a Certificate Signing Request (CSR) - ExAcme","doc":"After all challenges are validated, you can finalize the order by submitting a CSR.\n\n```elixir\nalias ExAcme.{Order, Certificate}\n\n# Create a private key for the certificate\nprivate_key = X509.PrivateKey.new_ec(:secp256r1)\n\n# Generate CSR from the order and private key\ncsr = Certificate.csr_from_order(order, private_key)\n\n# Finalize the order by submitting the CSR\ncase Order.finalize(order.finalize_url, csr, account_key, client) do\n  {:ok, finalized_order} ->\n    IO.puts(\"Order finalized successfully!\")\n    IO.inspect(finalized_order)\n\n  {:error, reason} ->\n    IO.puts(\"Failed to finalize order:\")\n    IO.inspect(reason)\nend\n```","ref":"readme.html#finalizing-the-order-with-a-certificate-signing-request-csr"},{"type":"extras","title":"Fetching the certificate - ExAcme","doc":"Once the order is finalized and the certificate is issued, you can fetch the certificate from the ACME server.\n\n```elixir\nalias ExAcme.Certificate\n\ncase Certificate.fetch(finalized_order.certificate_url, account_key, client) do\n  {:ok, certificates} ->\n    Enum.each(certificates, fn cert ->\n      IO.puts(\"Fetched Certificate:\")\n      IO.puts(X509.Certificate.to_pem(cert))\n    end)\n\n  {:error, reason} ->\n    IO.puts(\"Failed to fetch certificate:\")\n    IO.inspect(reason)\nend\n```","ref":"readme.html#fetching-the-certificate"},{"type":"extras","title":"License - ExAcme","doc":"This library is licensed under the [MIT License](https://opensource.org/licenses/MIT).","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}